#include <extdll.h>

#include <dllapi.h>
#include <meta_api.h>

extern unsigned char g_cFunMode;
extern float g_fTimeFunUpdate;

void TurnOffFunStuff(void);
void DoFunStuff(void);

void PODFun_ServerCommand(void)
{
   const char *arg1 = CMD_ARGV(1);

   if (*arg1)
   {
      TurnOffFunStuff();
      if (FStrEq(arg1, "imsober"))
      {
         SERVER_PRINT("Back to Life, back to Reality\n");
         g_cFunMode = 0;
      }
      else if (FStrEq(arg1, "tronisback"))
      {
         SERVER_PRINT("from the eighties with Love\n");
         g_cFunMode = 1;
      }
      else if (FStrEq(arg1, "itsnewyear"))
      {
         SERVER_PRINT("Really? That soon?\n");
         g_cFunMode = 2;
      }
      else if (FStrEq(arg1, "imhaunted"))
      {
         SERVER_PRINT("and the Ghosts are coming for you\n");
         g_cFunMode = 3;
      }
      else if (FStrEq(arg1, "itstoodark"))
      {
         SERVER_PRINT("the Bots will light your way\n");
         g_cFunMode = 4;
      }
      else if (FStrEq(arg1, "stonedagain"))
      {
         SERVER_PRINT("feeling dizzy now?\n");
         g_cFunMode = 5;
      }
   }
}

void StartFrame(void)
{
   if (g_cFunMode)
      DoFunStuff();
   RETURN_META(MRES_IGNORED);
}

static DLL_FUNCTIONS gFunctionTable = 
{
	NULL,         			// pfnGameInit
	NULL,					// pfnSpawn
	NULL,					// pfnThink
	NULL,					// pfnUse
	NULL,					// pfnTouch
	NULL,					// pfnBlocked
	NULL,					// pfnKeyValue
	NULL,					// pfnSave
	NULL,					// pfnRestore
	NULL,					// pfnSetAbsBox

	NULL,					// pfnSaveWriteFields
	NULL,					// pfnSaveReadFields

	NULL,					// pfnSaveGlobalState
	NULL,					// pfnRestoreGlobalState
	NULL,					// pfnResetGlobalState

	NULL,					// pfnClientConnect
	NULL,					// pfnClientDisconnect
	NULL,					// pfnClientKill
	NULL,					// pfnClientPutInServer
	NULL,					// pfnClientCommand
	NULL,					// pfnClientUserInfoChanged
	NULL,					// pfnServerActivate
	NULL,					// pfnServerDeactivate

	NULL,					// pfnPlayerPreThink
	NULL,					// pfnPlayerPostThink

	StartFrame,				// pfnStartFrame
	NULL,					// pfnParmsNewLevel
	NULL,					// pfnParmsChangeLevel

	NULL,					// pfnGetGameDescription
	NULL,					// pfnPlayerCustomization

	NULL,					// pfnSpectatorConnect
	NULL,					// pfnSpectatorDisconnect
	NULL,					// pfnSpectatorThink
	
	NULL,					// pfnSys_Error

	NULL,					// pfnPM_Move
	NULL,					// pfnPM_Init
	NULL,					// pfnPM_FindTextureType
	
	NULL,					// pfnSetupVisibility
	NULL,					// pfnUpdateClientData
	NULL,					// pfnAddToFullPack
	NULL,					// pfnCreateBaseline
	NULL,					// pfnRegisterEncoders
	NULL,					// pfnGetWeaponData
	NULL,					// pfnCmdStart
	NULL,					// pfnCmdEnd
	NULL,					// pfnConnectionlessPacket
	NULL,					// pfnGetHullBounds
	NULL,					// pfnCreateInstancedBaselines
	NULL,					// pfnInconsistentFile
	NULL,					// pfnAllowLagCompensation
};

C_DLLEXPORT int GetEntityAPI2(DLL_FUNCTIONS *pFunctionTable, 
		int *interfaceVersion)
{
	if(!pFunctionTable) {
		UTIL_LogPrintf("GetEntityAPI2 called with null pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION) {
		UTIL_LogPrintf("GetEntityAPI2 version mismatch; requested=%d ours=%d", *interfaceVersion, INTERFACE_VERSION);
		//! Tell metamod what version we had, so it can figure out who is out of date.
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pFunctionTable, &gFunctionTable, sizeof(DLL_FUNCTIONS));
	return(TRUE);
}
