#include <extdll.h>

#include <dllapi.h>
#include <meta_api.h>

unsigned char g_cFunMode = 0;
float g_fTimeFunUpdate = 0.0;

void TurnOffFunStuff(void)
{
   for (int i = 1; i <= gpGlobals->maxClients; i++)
   {
      edict_t *pEdict = INDEXENT(i);
      if (!FNullEnt(pEdict))
      {
         pEdict->v.rendermode = kRenderNormal;
         pEdict->v.renderfx = kRenderFxNone;
         pEdict->v.rendercolor.x = 0;
         pEdict->v.rendercolor.y = 0;
         pEdict->v.rendercolor.z = 0;
         pEdict->v.renderamt = 0;
         pEdict->v.effects &= ~EF_BRIGHTLIGHT;
      }
   }

   g_fTimeFunUpdate = 0.0;
   CVAR_SET_FLOAT("sv_gravity", 800.0);
}

int GetTeam(edict_t *pEntity)
{
   char t = g_engfuncs.pfnInfoKeyValue(g_engfuncs.pfnGetInfoKeyBuffer(pEntity), "model")[2];
   if (t == 'r' || t == 'a' || t == 'e' || t == 'c')
      return 0;
   return 1;
}

void DoFunStuff(void)
{
   Vector vecMisc;
   int i;
   edict_t *pEdict;

   switch (g_cFunMode)
   {
      // Cyberspace
      case 1:
         if (g_fTimeFunUpdate <= gpGlobals->time)
         {
            for (i = 1; i <= gpGlobals->maxClients; i++ )
            {
               pEdict = INDEXENT(i);
               if (FNullEnt(pEdict))
                  continue;
               if (pEdict->v.effects & EF_NODRAW)
                  continue;
               if (GetTeam(pEdict) == 0)
               {
                  pEdict->v.renderfx = kRenderFxGlowShell;
                  pEdict->v.rendercolor.x = 255;  // red
                  pEdict->v.rendercolor.y = 0;  // green
                  pEdict->v.rendercolor.z = 0; // blue
                  pEdict->v.renderamt = 10;  // glow shell distance from entity
               }
               else
               {
                  pEdict->v.renderfx = kRenderFxGlowShell;
                  pEdict->v.rendercolor.x = 0;  // red
                  pEdict->v.rendercolor.y = 0;  // green
                  pEdict->v.rendercolor.z = 255; // blue
                  pEdict->v.renderamt = 10;  // glow shell distance from entity
               }
            }
            g_fTimeFunUpdate = gpGlobals->time + 9999.0;
         }
         break;

         // New Year
      case 2:
         for (i = 1; i <= gpGlobals->maxClients; i++ )
         {
            pEdict = INDEXENT(i);
            if (FNullEnt(pEdict))
               continue;
            if (pEdict->v.effects & EF_NODRAW)
               continue;
            vecMisc = pEdict->v.origin + pEdict->v.view_ofs;
            MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecMisc );
            WRITE_BYTE( TE_SPARKS );
            WRITE_COORD( vecMisc.x );
            WRITE_COORD( vecMisc.y );
            WRITE_COORD( vecMisc.z );
            MESSAGE_END();
         }
         break;

         // Haunted
      case 3:
         for (i = 1; i <= gpGlobals->maxClients; i++ )
         {
            pEdict = INDEXENT(i);
            if (FNullEnt(pEdict))
               continue;
            if (pEdict->v.effects & EF_NODRAW)
               continue;
            pEdict->v.rendermode = kRenderTransTexture;
            pEdict->v.renderamt = 100;
         }
         break;

         // Light
      case 4:
         for (i = 1; i <= gpGlobals->maxClients; i++ )
         {
            pEdict = INDEXENT(i);
            if (FNullEnt(pEdict))
               continue;
            if (pEdict->v.effects & EF_NODRAW)
               continue;
            pEdict->v.effects |= EF_BRIGHTLIGHT;
         }
         break;

         // Stoned
      case 5:
         if (g_fTimeFunUpdate <= gpGlobals->time)
         {
            for (i = 1; i <= gpGlobals->maxClients; i++ )
            {
               pEdict = INDEXENT(i);
               if (FNullEnt(pEdict))
                  continue;
               if (pEdict->v.effects & EF_NODRAW)
                  continue;
               UTIL_ScreenShake( pEdict->v.origin, 2048.0, 1.0, 10.0, 0 );
               g_fTimeFunUpdate = gpGlobals->time + RANDOM_FLOAT(10.0, 20.0);
            }
         }
         break;
   }
}
